math.randomseed(os.time())
p,robots,crashes,gameover,lv,deadbots,tile,bg,robotimg,crashimg = {x = 15, y = 9, img = Image.load("player.png")},{},{},false,0,0, Image.createEmpty(16,16),Image.createEmpty(480,272),Image.load("robot.png"),Image.load("crash.png")

tile:clear(Color.new(0,50,150))
bg:clear(Color.new(0,0,255))
for i = 0, 29 do
	for j = 0, 16 do
		if (math.floor(i/2) == i/2 and math.floor(j/2) == j/2) or (math.floor(i/2) ~= i/2 and math.floor(j/2) ~= j/2) then
			bg:blit(i*16,j*16,tile)
		end
	end
end

function runrobots()
	for i = 1, table.getn(robots) do
		if robots[i].x > p.x then
			robots[i].x = robots[i].x - 1
		elseif robots[i].x < p.x then
			robots[i].x = robots[i].x + 1
		end
		if robots[i].y > p.y then
			robots[i].y = robots[i].y - 1
		elseif robots[i].y < p.y then
			robots[i].y = robots[i].y + 1
		end
		if robots[i].x == p.x and robots[i].y == p.y then
			gameover = true
		end
		for j = 1, table.getn(robots) do
			if robots[i].x == robots[j].x and robots[i].y == robots[j].y and j~=i then
				table.insert(crashes,{x=robots[i].x,y=robots[i].y})
				break
			end
		end
	end
	for j = 1, table.getn(crashes) do
		i = 1
		while i <= table.getn(robots) do
			if robots[i].x == crashes[j].x and robots[i].y == crashes[j].y then
				table.remove(robots,i)
				deadbots = deadbots + 1
			end
			i = i + 1
		end
	end
	if table.getn(robots) < 1 then
		lv = lv + 1
		for i = 1, lv*5 do
			table.insert(robots,{x=math.random(0,29),y=math.random(0,16)})
		end
		while onthesametile do
			onthesametile=false
			for i = 1, table.getn(robots) do
				if robots[i].x == p.x and robots[i].y == p.y then
					onthesametile = true
					robots[i].x = math.random(0,29) robots[i].y = math.random(0,16)
				end
				for j = 1, table.getn(robots) do
					if robots[i].x == robots[j].x and robots[i].y == robots[j].y and j~=i then
						onthesametile = true
						robots[j].x = math.random(0,29) robots[j].y = math.random(0,16)
					end
				end
			end
		end
	end
end

runrobots()
while true do
	screen:clear()
	pad = Controls.read()

	if not gameover then
		screen:blit(0,0,bg)
		screen:blit(p.x*16,p.y*16,p.img)
		for i = 1, table.getn(robots) do
			screen:blit(robots[i].x*16,robots[i].y*16,robotimg)
		end
		for i = 1, table.getn(crashes) do
			screen:blit(crashes[i].x*16,crashes[i].y*16,crashimg)
		end
		if pad:left() and not oldpad:left() and p.x > 0 then
			p.x = p.x - 1
			runrobots()
		elseif pad:right() and not oldpad:right() and p.x < 29 then
			p.x = p.x + 1
			runrobots()
		elseif pad:up() and not oldpad:up() and p.y > 0 then
			p.y = p.y - 1
			runrobots()
		elseif pad:down() and not oldpad:down() and p.y < 16 then
			p.y = p.y + 1
			runrobots()
		elseif pad:cross() and not oldpad:cross() then
			p.x = math.random(0,29)
			p.y = math.random(0,16)
			runrobots()
		end
	else
		screen:print(168,2,"Gameover! Score: "..deadbots, Color.new(255,255,255))
	end

	screen.waitVblankStart()
	screen.flip()
	oldpad = pad
	if pad:start() then break end
end